## tulip 3.7.0dfsg

=== CMakeLists.txt ===
## -----------------------------------------------------------------------------------------------
## ***********************************************************************************************
## -----------------------------------------------------------------------------------------------
##
## Options for cmake (use -D):
## CMAKE_INSTALL_PREFIX=directory_where_tulip_will_be_installed
## NO_DEPRECATE=1 disable display of deprecated warning
##
## -----------------------------------------------------------------------------------------------
## ***********************************************************************************************
## -----------------------------------------------------------------------------------------------

PROJECT(tulip)

CMAKE_MINIMUM_REQUIRED(VERSION 2.6)

SET(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_SOURCE_DIR})

IF(CMAKE_COMPILER_IS_GNUCXX) #visual studio does not recognize these options
   SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Wextra -Wunused")
ENDIF()

IF(WIN32)
	IF(NOT MSVC) #visual studio does not recognize these options 
		
		# Dynamic ling against libstdc++ on win32/MinGW 
		# The second test is for the case where ccache is used (CMAKE_CXX_COMPILER_ARG1 contains the path to the g++ compiler)
		IF (CMAKE_COMPILER_IS_GNUCXX OR "${CMAKE_CXX_COMPILER_ARG1}" MATCHES ".*[g][+][+].*")
			EXECUTE_PROCESS(COMMAND ${CMAKE_CXX_COMPILER} ${CMAKE_CXX_COMPILER_ARG1} -dumpversion
							OUTPUT_VARIABLE GCXX_VERSION)
							
			IF(GCXX_VERSION VERSION_GREATER 4.0)
		
				SET(CMAKE_EXE_LINKER_FLAGS_DEBUG "${CMAKE_EXE_LINKER_FLAGS_DEBUG} -Wl,-subsystem,console")
				SET(CMAKE_MODULE_LINKER_FLAGS_DEBUG "${CMAKE_EXE_LINKER_FLAGS_DEBUG} -Wl,-subsystem,console")
				SET(CMAKE_SHARED_LINKER_FLAGS_DEBUG "${CMAKE_EXE_LINKER_FLAGS_DEBUG} -Wl,-subsystem,console")

				#GCC 4.4 use double dashes and gcc 4.6 single dashes for this option
				IF(GCXX_VERSION VERSION_LESS 4.6)
					SET(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} --shared-libgcc -Wl,--allow-multiple-definition")
					SET(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} --shared-libgcc  -Wl,--allow-multiple-definition")
					SET(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} --shared-libgcc  -Wl,--allow-multiple-definition")
				ELSE()
					SET(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -shared-libgcc -Wl,--allow-multiple-definition")
					SET(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} -shared-libgcc  -Wl,--allow-multiple-definition")
					SET(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -shared-libgcc  -Wl,--allow-multiple-definition")
				ENDIF()
	  
			ENDIF()
			
			IF(GCXX_VERSION VERSION_GREATER 4.5 OR GCXX_VERSION VERSION_EQUAL 4.5)
				#mingw 4.4.0 cannot link the tulip core library as it does not have exceptions symbols correctly defined (MinGW bug #2836185)
				SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -D_GLIBCXX_DLL")	
			ENDIF()
			SET(CMAKE_CXX_STANDARD_LIBRARIES "${CMAKE_CXX_STANDARD_LIBRARIES} -lstdc++")
	ENDIF()
 ENDIF()
ENDIF()

## -----------------------------------------------------------------------------------------------
## build type detection
IF(CMAKE_BUILD_TYPE MATCHES "[Dd][Ee][Bb][Uu][Gg]")
   SET(CMAKE_DEBUG_MODE TRUE)
ELSE(CMAKE_BUILD_TYPE MATCHES "[Dd][Ee][Bb][Uu][Gg]")
   SET(CMAKE_DEBUG_MODE FALSE)
ENDIF(CMAKE_BUILD_TYPE MATCHES "[Dd][Ee][Bb][Uu][Gg]")
## -----------------------------------------------------------------------------------------------
## Tulip version numbers
## TulipVersion : Ma.Mi.Re
## TulipMMVersion : Ma.Mi
## -----------------------------------------------------------------------------------------------
SET(TulipMajorVersion 3)
SET(TulipMinorVersion 7)
SET(TulipReleaseVersion 0)
SET(TulipVersionSeparator .)
IF(MSVC) #specific options for Visual Studio
	IF(${CMAKE_GENERATOR} MATCHES "Visual Studio 9") #visual studio 2008 needs boost
		find_package(BOOST REQUIRED)
		include_directories(${Boost_INCLUDE_DIRS})
		include_directories(${Boost_INCLUDE_DIRS}/boost/tr1)
	ENDIF()
   SET(TulipVersionSeparator _)
ENDIF()
SET(TulipVersion "${TulipMajorVersion}${TulipVersionSeparator}${TulipMinorVersion}${TulipVersionSeparator}${TulipReleaseVersion}")
SET(TulipMMVersion "${TulipMajorVersion}${TulipVersionSeparator}${TulipMinorVersion}")
SET(TulipIntVersion "${TulipMajorVersion}${TulipMinorVersion}${TulipReleaseVersion}")

## -----------------------------------------------------------------------------------------------
## Lib names
## -----------------------------------------------------------------------------------------------
SET(LibTulipName "tulip-${TulipMMVersion}")
SET(LibTulipOglName "tulip-ogl-${TulipMMVersion}")
SET(LibTulipQtName "tulip-qt4-${TulipMMVersion}")
SET(LibTulipOGDFName "tulip-ogdf-${TulipMMVersion}")
SET(LibTulipPluginsManagerName "tulip-pluginsmanager-${TulipMMVersion}")
SET(LibStlPythonName "stlpython")
SET(LibTulipPythonName "tulippython")

## -----------------------------------------------------------------------------------------------
## Special compilation mode when building Ubuntu packages through a PPA
## -----------------------------------------------------------------------------------------------

SET(UBUNTU_PPA_BUILD OFF CACHE INTERNAL "")


## -----------------------------------------------------------------------------------------------
## Find need packages
## -----------------------------------------------------------------------------------------------
FIND_PACKAGE(Freetype REQUIRED)
FIND_PACKAGE(Qt4 4.5.0 REQUIRED)
INCLUDE(${QT_USE_FILE})
IF(DEFINED CMAKE_VERSION)
  SET(HAVE_QT4_GET_MOC_FLAGS TRUE)
ELSE(DEFINED CMAKE_VERSION)
  MACRO (QT4_GET_MOC_FLAGS _moc_flags)
     SET(${_moc_flags})
     GET_DIRECTORY_PROPERTY(_inc_DIRS INCLUDE_DIRECTORIES)

     FOREACH(_current ${_inc_DIRS})
        SET(${_moc_flags} ${${_moc_flags}} "-I${_current}")
     ENDFOREACH(_current ${_inc_DIRS})

     GET_DIRECTORY_PROPERTY(_defines COMPILE_DEFINITIONS)
     FOREACH(_current ${_defines})
        SET(${_moc_flags} ${${_moc_flags}} "-D${_current}")
     ENDFOREACH(_current ${_defines})

     IF(Q_WS_WIN)
       SET(${_moc_flags} ${${_moc_flags}} -DWIN32)
     ENDIF(Q_WS_WIN)

  ENDMACRO(QT4_GET_MOC_FLAGS)
ENDIF(DEFINED CMAKE_VERSION)
FIND_PACKAGE(OpenGL REQUIRED)
FIND_PACKAGE(JPEG REQUIRED)
IF(JPEG_FOUND)
   SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DHAVE_LIBJPEG")
ENDIF(JPEG_FOUND)
FIND_PACKAGE(PNG REQUIRED)
IF(PNG_FOUND)
   SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DHAVE_LIBPNG")
ENDIF(PNG_FOUND)

INCLUDE(FindGLEW.cmake)
IF(NOT GLEW_FOUND)
   message(FATAL_ERROR "Cannot find the GLEW library (required)")
ENDIF(NOT GLEW_FOUND)
INCLUDE(FindXML2.cmake)
IF(NOT LIBXML2_FOUND)
   message(FATAL_ERROR "Cannot find the XML2 library (required)")
ENDIF(NOT LIBXML2_FOUND)

## -----------------------------------------------------------------------------------------------
## OpenMP
## -----------------------------------------------------------------------------------------------

FIND_PACKAGE (Threads)
FIND_PACKAGE(OpenMP QUIET)
IF(OPENMP_FOUND)
   SET(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} ${OpenMP_CXX_FLAGS}")
   SET(OPENMP_CXX_FLAGS "${OpenMP_CXX_FLAGS}")
   IF(WIN32)
	  IF(MSVC)
		SET(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} /openmp")
		SET(OPENMP_CXX_FLAGS "/openmp")
	  ELSE()
		SET(CMAKE_CXX_STANDARD_LIBRARIES "${CMAKE_CXX_STANDARD_LIBRARIES} -lgomp ${CMAKE_THREAD_LIBS_INIT}")
		SET(OPENMP_LIBRARIES "-lgomp -lpthread")
	  ENDIF()
   ENDIF()
ELSE(OPENMP_FOUND)
  IF(WIN32)
   STRING(COMPARE NOTEQUAL "${OpenMP_C_FLAGS}" "" OMP_CFLAGS)
   IF(OMP_CFLAGS)
      ## HACK: do not know why OpenMP_CXX_FLAGS
      ## is not set when running on window ?
      SET(CMAKE_CXX_FLAGS_RELEASES "${CMAKE_CXX_FLAGS_RELEASE} ${OpenMP_C_FLAGS}")
      SET(OPENMP_CXX_FLAGS "${OpenMP_C_FLAGS}")
      SET(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} ${OpenMP_C_FLAGS}")
      SET(OPENMP_LINKER_FLAGS "${OpenMP_C_FLAGS}")
      SET(CMAKE_CXX_STANDARD_LIBRARIES "${CMAKE_CXX_STANDARD_LIBRARIES} -lgomp -lpthread")
      SET(OPENMP_LIBRARIES "-lgomp -lpthread")
      SET(OPENMP_FOUND TRUE)
   ELSE(OMP_CFLAGS)
      MESSAGE("OpenMP not found: multithreaded code will not be used")
   ENDIF(OMP_CFLAGS)
  ELSE(WIN32)
    MESSAGE("OpenMP not found: multithreaded code will not be used")
  ENDIF(WIN32)
ENDIF(OPENMP_FOUND)

## -----------------------------------------------------------------------------------------------
## Python (not required)
## -----------------------------------------------------------------------------------------------

# Try to find Python in first place

# If Python is present, compile SIP before launching the whole Tulip build  
# because we need it later in the configure process 

FIND_PACKAGE(PythonLibs)
FIND_PACKAGE(PythonInterp)

IF(PYTHONLIBS_FOUND AND PYTHONINTERP_FOUND)
  IF(NOT UBUNTU_PPA_BUILD)
    SET(SIP_LIB sip)
    TRY_COMPILE(SIP_OK ${CMAKE_CURRENT_BINARY_DIR}/thirdparty/sip-4.12.1/sipgen ${CMAKE_CURRENT_SOURCE_DIR}/thirdparty/sip-4.12.1/sipgen sip CMAKE_FLAGS -DCMAKE_OSX_ARCHITECTURES=${CMAKE_OSX_ARCHITECTURES})
    IF(SIP_OK)
      IF(WIN32 AND EXISTS "${CMAKE_CURRENT_BINARY_DIR}/thirdparty/sip-4.12.1/sipgen/Debug/sip.exe")
	SET(SIP_EXE ${CMAKE_CURRENT_BINARY_DIR}/thirdparty/sip-4.12.1/sipgen/Debug/sip.exe)
      ELSE()
	SET(SIP_EXE ${CMAKE_CURRENT_BINARY_DIR}/thirdparty/sip-4.12.1/sipgen/sip)
      ENDIF()
      SET(SIP_INCLUDE_DIR ${CMAKE_CURRENT_SOURCE_DIR}/thirdparty/sip-4.12.1/siplib/)
    ENDIF(SIP_OK)
  ELSE()
    FIND_PACKAGE(SIP)
    SET(SIP_OK ${SIP_FOUND})
    IF (SIP_OK)
      SET(SIP_EXE "${SIP_EXECUTABLE}")
    ENDIF()
  ENDIF()

  EXECUTE_PROCESS(COMMAND ${PYTHON_EXECUTABLE} -c "import sys;print str(sys.version_info[0])+\".\"+str(sys.version_info[1])"
		  OUTPUT_VARIABLE PYTHON_VERSION)
  STRING(REPLACE "\n" "" PYTHON_VERSION "${PYTHON_VERSION}")

  SET(Sphinx_DIR ${CMAKE_CURRENT_SOURCE_DIR}/docs/python)
  MARK_AS_ADVANCED(Sphinx_DIR)
  FIND_PACKAGE(Sphinx)

ENDIF(PYTHONLIBS_FOUND AND PYTHONINTERP_FOUND)

## -----------------------------------------------------------------------------------------------
## Include file paths
## -----------------------------------------------------------------------------------------------
SET(GZStreamInclude ${PROJECT_SOURCE_DIR}/thirdparty/gzstream/)
SET(GZStreamLibrary gzstream)
SET(OGDFInclude ${PROJECT_SOURCE_DIR}/thirdparty/OGDF)
SET(OGDFLibrary OGDF)
IF(UBUNTU_PPA_BUILD)
  FIND_PACKAGE(FTGL)  
  SET(FTGLInclude ${FTGL_INCLUDE_DIR})
ELSE()
  SET(FTGLInclude ${PROJECT_SOURCE_DIR}/thirdparty/ftgl/)
ENDIF()

SET(TulipInclude ${PROJECT_SOURCE_DIR}/library/tulip/include/)
SET(TulipBuildInclude ${PROJECT_BINARY_DIR}/library/tulip/include/)
SET(TulipOGLInclude ${PROJECT_SOURCE_DIR}/library/tulip-ogl/include/)
SET(TulipOGDFInclude ${PROJECT_SOURCE_DIR}/library/tulip-ogdf/)
SET(TulipQtInclude ${PROJECT_SOURCE_DIR}/library/tulip-qt/include/)
SET(TulipQtBuildInclude ${PROJECT_BINARY_DIR}/library/tulip-qt/include/)
SET(TulipPluginsManagerInclude ${PROJECT_SOURCE_DIR}/software/plugins-manager/include/)

## -----------------------------------------------------------------------------------------------
## Install paths
## -----------------------------------------------------------------------------------------------
IF(APPLE)
SET(TulipAppleContentsDir Tulip-${TulipVersion}.app/Contents/)
SET(TulipBinInstallDir ${TulipAppleContentsDir}MacOS/)
SET(TulipLibInstallDir ${TulipAppleContentsDir}Frameworks/)
SET(TulipIncludeInstallDir ${TulipAppleContentsDir}include/)
SET(TulipShareInstallDir ${TulipAppleContentsDir}share/tulip)
SET(TulipPluginsInstallDir ${TulipAppleContentsDir}lib/tulip/)
SET(TulipBitmapInstallDir ${TulipShareInstallDir}/bitmaps/)
SET(TulipAppleResourcesDir ${TulipAppleContentsDir}Resources/)
ELSE()
SET(TulipLibInstallDir lib/)
SET(TulipPluginsInstallDir ${TulipLibInstallDir}/tulip/)
SET(TulipBinInstallDir bin/)
SET(TulipIncludeInstallDir include/)
SET(TulipShareInstallDir share/tulip)

=== docs/CMakeLists.txt ===
IF(LINUX)
  FIND_PACKAGE(Doxygen)
  IF(DOXYGEN_FOUND)

    ## -----------------------------------------------------------------------------------------------
    ## Builds the documentation
    ## -----------------------------------------------------------------------------------------------
    SET(BUILD_DOC OFF CACHE BOOL "Do you want to build the documentation ? [OFF|ON]")
    #Only
    IF(BUILD_DOC)
        SET(TULIP_LIB_DESC "Tulip Graph Library")
        SET(TULIP_LIB_NAME "tulip")
        CONFIGURE_FILE("doxygen/tulip-lib.doxygen.in" "${CMAKE_CURRENT_BINARY_DIR}/doxygen/tulip-lib.doxygen" @ONLY)
        SET(TULIP_LIB_DESC "Tulip Open GL Library")
        SET(TULIP_LIB_NAME "tulip-ogl")
        CONFIGURE_FILE("doxygen/tulip-lib.doxygen.in" "${CMAKE_CURRENT_BINARY_DIR}/doxygen/tulip-ogl-lib.doxygen" @ONLY)
        SET(TULIP_LIB_DESC "Tulip Qt Library")
        SET(TULIP_LIB_NAME "tulip-qt")
        CONFIGURE_FILE("doxygen/tulip-lib.doxygen.in" "${CMAKE_CURRENT_BINARY_DIR}/doxygen/tulip-qt-lib.doxygen" @ONLY)
        EXEC_PROGRAM(date ARGS "+%Y" OUTPUT_VARIABLE THIS_YEAR)
        CONFIGURE_FILE("doxygen/tulip.html.in" "${CMAKE_CURRENT_BINARY_DIR}/doxygen/tulip.html")
        CONFIGURE_FILE("doxygen/header.html.in" "${CMAKE_CURRENT_BINARY_DIR}/doxygen/header.html")
        CONFIGURE_FILE("doxygen/footer.html.in" "${CMAKE_CURRENT_BINARY_DIR}/doxygen/footer.html")
        CONFIGURE_FILE("doxygen/header-allPlugins.html.in" "${CMAKE_CURRENT_BINARY_DIR}/doxygen/header-allPlugins.html")
        CONFIGURE_FILE("doxygen/tulip-plugins.doxygen.in" "${CMAKE_CURRENT_BINARY_DIR}/doxygen/tulip-plugins.doxygen")
        CONFIGURE_FILE("developerHandbook/gen-devPdf.sh.in" "${CMAKE_CURRENT_BINARY_DIR}/developerHandbook/gen-devPdf.sh")
        CONFIGURE_FILE("userHandbook/gen-userPdf.sh.in" "${CMAKE_CURRENT_BINARY_DIR}/userHandbook/gen-userPdf.sh")
        CONFIGURE_FILE("make_tulip_doc_tarball.sh.in" "${CMAKE_CURRENT_BINARY_DIR}/make_tulip_doc_tarball.sh" @ONLY)

        include_directories(${KDE4_INCLUDES} ${KDE4_INCLUDE_DIR} ${QT_INCLUDES} )

        add_subdirectory(common)
        add_subdirectory(doxygen)
        add_subdirectory(userHandbook)
        add_subdirectory(developerHandbook)

        CONFIGURE_FILE("tulip.qhcp.in" "${CMAKE_CURRENT_BINARY_DIR}/tulip.qhcp" @ONLY)
        ADD_CUSTOM_TARGET(tulip_qhp sh ${PROJECT_SOURCE_DIR}/docs/gen-tulipqhp.sh ${CMAKE_CURRENT_BINARY_DIR}/tulip.qhp)
        ADD_CUSTOM_TARGET(tulip_qch qhelpgenerator ${CMAKE_CURRENT_BINARY_DIR}/tulip.qhp -o ${CMAKE_CURRENT_BINARY_DIR}/tulip${TulipIntVersion}.qch)
        ADD_CUSTOM_TARGET(doc ALL qcollectiongenerator ${CMAKE_CURRENT_BINARY_DIR}/tulip.qhcp -o ${CMAKE_CURRENT_BINARY_DIR}/tulip${TulipIntVersion}.qhc WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})

        ADD_DEPENDENCIES(tulip_qhp dev_toc dev_keywords dox_toc dox_keywords user_toc user_keywords allPlugins-html tulip-libs-html)
        ADD_DEPENDENCIES(tulip_qch tulip_qhp)
        ADD_DEPENDENCIES(doc tulip_qch tulip_qhcp)

        INSTALL(DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/common
            DESTINATION share/doc/tulip
            COMPONENT tulip_doc)
    ENDIF(BUILD_DOC)
  ELSE()
  	MESSAGE("Doxygen not found: unable to generate documentation")
  ENDIF()
ENDIF(LINUX)

add_subdirectory(python)

ADD_CUSTOM_TARGET(doc_generation ALL
${CMAKE_COMMAND} -E touch ${CMAKE_CURRENT_BINARY_DIR}/tulip${TulipIntVersion}.qhc
COMMAND ${CMAKE_COMMAND} -E touch ${CMAKE_CURRENT_BINARY_DIR}/tulip${TulipIntVersion}.qch
COMMENT "Checking if documentation files are present")

INSTALL(FILES ${CMAKE_CURRENT_BINARY_DIR}/tulip${TulipIntVersion}.qhc ${CMAKE_CURRENT_BINARY_DIR}/tulip${TulipIntVersion}.qch
  DESTINATION ${TulipShareInstallDir}
  COMPONENT tulip_doc)

=== externalplugins/CMakeLists.txt ===
set(CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/ ${CMAKE_MODULE_PATH})
CMAKE_MINIMUM_REQUIRED(VERSION 2.6)

#Automatic subdirectory search for CMakeLists.txt
FILE(GLOB CM_FILES RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_SOURCE_DIR}/*/CMakeLists.txt)

FOREACH(CM_FILE ${CM_FILES})
STRING(REGEX REPLACE "//CMakeLists.txt" "" CM_SUBDIR ${CM_FILE})
ADD_SUBDIRECTORY(${CM_SUBDIR})
ENDFOREACH(CM_FILE)

=== library/CMakeLists.txt ===
ADD_SUBDIRECTORY(tulip)
ADD_SUBDIRECTORY(tulip-ogl)
ADD_SUBDIRECTORY(tulip-qt)
ADD_SUBDIRECTORY(tulip-python)
ADD_SUBDIRECTORY(tulip-ogdf)

=== plugins/CMakeLists.txt ===
IF(CHECK_MEMORY)
  SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${CHECK_MEMORY_FLAGS}")
ENDIF(CHECK_MEMORY)

ADD_SUBDIRECTORY(clustering)
ADD_SUBDIRECTORY(colors)
ADD_SUBDIRECTORY(import)
ADD_SUBDIRECTORY(layout)
ADD_SUBDIRECTORY(metric)
ADD_SUBDIRECTORY(selection)
ADD_SUBDIRECTORY(sizes)
ADD_SUBDIRECTORY(export)
ADD_SUBDIRECTORY(glyph)
ADD_SUBDIRECTORY(view)
ADD_SUBDIRECTORY(interactor)

=== samples/CMakeLists.txt ===

include_directories(${KDE4_INCLUDES} ${KDE4_INCLUDE_DIR} ${QT_INCLUDES} )

add_subdirectory(gml)
add_subdirectory(matrix)
add_subdirectory(tlp)


########### install files ###############




#original Makefile.am contents follow:

#SUBDIRS = gml matrix tlp

=== software/CMakeLists.txt ===
IF(CHECK_MEMORY)
  SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${CHECK_MEMORY_FLAGS}")
ENDIF(CHECK_MEMORY)

ADD_SUBDIRECTORY(plugins-manager)
ADD_SUBDIRECTORY(crash_handling)
ADD_SUBDIRECTORY(tulip)
#ADD_SUBDIRECTORY(tlprender)

=== textures/CMakeLists.txt ===
INSTALL(FILES
  arrowSprite.png
  candiSprite.png
  edgeBlomSprite.png
  edgeSpring.png
  titlebarGradient.png
DESTINATION ${TulipBitmapInstallDir}
COMPONENT tulip
)

=== thirdparty/CMakeLists.txt ===
ADD_SUBDIRECTORY(gzstream)
ADD_SUBDIRECTORY(OGDF)

IF(NOT UBUNTU_PPA_BUILD)
ADD_SUBDIRECTORY(ftgl)
ENDIF()

IF(PYTHONLIBS_FOUND AND PYTHONINTERP_FOUND)
IF(SIP_OK AND NOT UBUNTU_PPA_BUILD)
ADD_SUBDIRECTORY(sip-4.12.1)
ENDIF(SIP_OK AND NOT UBUNTU_PPA_BUILD)
ENDIF(PYTHONLIBS_FOUND AND PYTHONINTERP_FOUND)

=== docs/common/CMakeLists.txt ===
EXECUTE_PROCESS(COMMAND ${CMAKE_COMMAND} -E copy_directory ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_BINARY_DIR})
IF(UBUNTU_PPA_BUILD)
   FILE(READ ${CMAKE_CURRENT_BINARY_DIR}/tulip-html.xsl input)
   STRING(REPLACE "http://docbook.sourceforge.net/release/xsl/current/html/chunk.xsl" "file:/usr/share/xml/docbook/stylesheet/docbook-xsl/html/chunk.xsl" input "${input}") 
   FILE(WRITE ${CMAKE_CURRENT_BINARY_DIR}/tulip-html.xsl "${input}")
   FILE(READ ${CMAKE_CURRENT_BINARY_DIR}/tulip-pdf.xsl input)
   STRING(REPLACE "http://docbook.sourceforge.net/release/xsl/current/fo/docbook.xsl" "file:/usr/share/xml/docbook/stylesheet/docbook-xsl/fo/docbook.xsl" input "${input}") 
   FILE(WRITE ${CMAKE_CURRENT_BINARY_DIR}/tulip-pdf.xsl "${input}") 
ENDIF()

=== docs/developerHandbook/CMakeLists.txt ===
ADD_CUSTOM_TARGET(dev_images ${CMAKE_COMMAND} -E copy_directory ${CMAKE_CURRENT_SOURCE_DIR}/images ${CMAKE_CURRENT_BINARY_DIR}/images)

ADD_CUSTOM_TARGET(dev_html java -cp "${PROJECT_SOURCE_DIR}/thirdparty/saxon/saxon653.jar:${PROJECT_SOURCE_DIR}/thirdparty/saxon/saxon.jar:${PROJECT_SOURCE_DIR}/docs/common:${PROJECT_SOURCE_DIR}/thirdparty/xml-commons/resolver.jar" com.icl.saxon.StyleSheet -x org.apache.xml.resolver.tools.ResolvingXMLReader -y org.apache.xml.resolver.tools.ResolvingXMLReader -r org.apache.xml.resolver.tools.CatalogResolver -u ${PROJECT_SOURCE_DIR}/docs/developerHandbook/index.docbook ${PROJECT_SOURCE_DIR}/docs/common/tulip-html.xsl)

ADD_DEPENDENCIES(dev_html dev_images)

ADD_CUSTOM_TARGET(dev_toc java -cp "${PROJECT_SOURCE_DIR}/thirdparty/saxon/saxon653.jar:${PROJECT_SOURCE_DIR}/thirdparty/saxon/saxon.jar:${PROJECT_SOURCE_DIR}/docs/common:${PROJECT_SOURCE_DIR}/thirdparty/xml-commons/resolver.jar" com.icl.saxon.StyleSheet -x org.apache.xml.resolver.tools.ResolvingXMLReader -y org.apache.xml.resolver.tools.ResolvingXMLReader -r org.apache.xml.resolver.tools.CatalogResolver -o toc.dcf ${PROJECT_SOURCE_DIR}/docs/developerHandbook/index.docbook ${PROJECT_SOURCE_DIR}/docs/common/tulip-toc.xsl install.path="./developerHandbook/html/")

ADD_DEPENDENCIES(dev_toc dev_html) 

ADD_CUSTOM_TARGET(dev_keywords java -cp "${PROJECT_SOURCE_DIR}/thirdparty/saxon/saxon653.jar:${PROJECT_SOURCE_DIR}/thirdparty/saxon/saxon.jar:${PROJECT_SOURCE_DIR}/docs/common:${PROJECT_SOURCE_DIR}/thirdparty/xml-commons/resolver.jar" com.icl.saxon.StyleSheet -x org.apache.xml.resolver.tools.ResolvingXMLReader -y org.apache.xml.resolver.tools.ResolvingXMLReader -r org.apache.xml.resolver.tools.CatalogResolver -o keywords.dcf ${PROJECT_SOURCE_DIR}/docs/developerHandbook/index.docbook ${PROJECT_SOURCE_DIR}/docs/common/tulip-keywords.xsl install.path="./developerHandbook/html/")

ADD_DEPENDENCIES(dev_keywords dev_html)

INSTALL(DIRECTORY
 ${CMAKE_CURRENT_BINARY_DIR}/html
 ${CMAKE_CURRENT_BINARY_DIR}/images
DESTINATION share/doc/tulip/developerHandbook
COMPONENT tulip_doc)

=== docs/doxygen/CMakeLists.txt ===
ADD_CUSTOM_TARGET(tulip-libs-html sh ${PROJECT_SOURCE_DIR}/docs/common/gen-index.sh)

ADD_CUSTOM_TARGET(tulip-lib-html doxygen tulip-lib.doxygen WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})

ADD_CUSTOM_TARGET(tulip-libogl-html doxygen tulip-ogl-lib.doxygen WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})

ADD_CUSTOM_TARGET(tulip-libqt-html doxygen tulip-qt-lib.doxygen WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})

ADD_CUSTOM_TARGET(tulip-plugins-doc doxygen tulip-plugins.doxygen WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})

ADD_CUSTOM_TARGET(tulipPlugins-html java -cp "${PROJECT_SOURCE_DIR}/thirdparty/saxon/saxon653.jar:${PROJECT_SOURCE_DIR}/thirdparty/saxon/saxon.jar:${PROJECT_SOURCE_DIR}/docs/common:${PROJECT_SOURCE_DIR}/thirdparty/xml-commons/resolver.jar" com.icl.saxon.StyleSheet -x org.apache.xml.resolver.tools.ResolvingXMLReader -y org.apache.xml.resolver.tools.ResolvingXMLReader -r org.apache.xml.resolver.tools.CatalogResolver -o tulipPlugins.html tulip-plugins.tag  ${PROJECT_SOURCE_DIR}/docs/doxygen/dox-plugins.xsl)

ADD_DEPENDENCIES(tulipPlugins-html tulip-plugins-doc)
ADD_DEPENDENCIES(tulip-libs-html tulip-lib-html tulip-libogl-html tulip-libqt-html)

ADD_CUSTOM_TARGET(allPluginsBody-html java -cp "${PROJECT_SOURCE_DIR}/thirdparty/saxon/saxon653.jar:${PROJECT_SOURCE_DIR}/thirdparty/saxon/saxon.jar:${PROJECT_SOURCE_DIR}/docs/common:${PROJECT_SOURCE_DIR}/thirdparty/xml-commons/resolver.jar" com.icl.saxon.StyleSheet -x org.apache.xml.resolver.tools.ResolvingXMLReader -y org.apache.xml.resolver.tools.ResolvingXMLReader -r org.apache.xml.resolver.tools.CatalogResolver -o allPluginsBody.html tulip-plugins.tag ${PROJECT_SOURCE_DIR}/docs/doxygen/dox-html.xsl)

ADD_DEPENDENCIES(allPluginsBody-html tulip-plugins-doc)

ADD_CUSTOM_TARGET(allPlugins-html sh ${PROJECT_SOURCE_DIR}/docs/doxygen/gen-allPlugins.sh)

ADD_DEPENDENCIES(allPlugins-html allPluginsBody-html)

ADD_CUSTOM_TARGET(dox_toc java -cp "${PROJECT_SOURCE_DIR}/thirdparty/saxon/saxon653.jar:${PROJECT_SOURCE_DIR}/thirdparty/saxon/saxon.jar:${PROJECT_SOURCE_DIR}/docs/common:${PROJECT_SOURCE_DIR}/thirdparty/xml-commons/resolver.jar" com.icl.saxon.StyleSheet -x org.apache.xml.resolver.tools.ResolvingXMLReader -y org.apache.xml.resolver.tools.ResolvingXMLReader -r org.apache.xml.resolver.tools.CatalogResolver -o toc.dcf tulip-plugins.tag ${PROJECT_SOURCE_DIR}/docs/doxygen/dox-toc.xsl)

ADD_DEPENDENCIES(dox_toc tulipPlugins-html)

ADD_CUSTOM_TARGET(dox_keywords java -cp "${PROJECT_SOURCE_DIR}/thirdparty/saxon/saxon653.jar:${PROJECT_SOURCE_DIR}/thirdparty/saxon/saxon.jar:${PROJECT_SOURCE_DIR}/docs/common:${PROJECT_SOURCE_DIR}/thirdparty/xml-commons/resolver.jar" com.icl.saxon.StyleSheet -x org.apache.xml.resolver.tools.ResolvingXMLReader -y org.apache.xml.resolver.tools.ResolvingXMLReader -r org.apache.xml.resolver.tools.CatalogResolver -o keywords.dcf tulip-plugins.tag ${PROJECT_SOURCE_DIR}/docs/doxygen/dox-keywords.xsl)

ADD_DEPENDENCIES(dox_keywords tulipPlugins-html)

INSTALL(FILES ${CMAKE_CURRENT_BINARY_DIR}/tulip.html
	      ${CMAKE_CURRENT_BINARY_DIR}/tulipdoc.html
	      ${CMAKE_CURRENT_BINARY_DIR}/allPluginsBody.html
	      ${CMAKE_CURRENT_BINARY_DIR}/allPlugins.html
	      ${CMAKE_CURRENT_BINARY_DIR}/tulipPlugins.html
 DESTINATION share/doc/tulip/doxygen
 COMPONENT tulip_doc)

INSTALL(DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/tulip-lib
		  ${CMAKE_CURRENT_BINARY_DIR}/tulip-ogl-lib
		  ${CMAKE_CURRENT_BINARY_DIR}/tulip-qt-lib
 DESTINATION share/doc/tulip/doxygen
 COMPONENT tulip_doc)

=== debian/changelog ===
tulip (3.7.0dfsg-4) unstable; urgency=low

  * Completely disable crash handler on archs other than i386 and amd64,
    it currenty requires explicit knowledge of the architecture's
    instruction pointer (<sigh> should have read upstream code at first...).

 -- Yann Dirson <dirson@debian.org>  Sat, 19 May 2012 14:07:32 +0200

tulip (3.7.0dfsg-3) unstable; urgency=low

  * Replace all remaining uses of __linux and __linux__ by __unix__.
  * Restrict binutils-dev build-depend any-i386 and any-amd64 instead of
    using negation (which did not appear to work for any reason ?).
  * Add license paragraph for "Files: *" (lintian).

 -- Yann Dirson <dirson@debian.org>  Sat, 19 May 2012 10:32:50 +0200

tulip (3.7.0dfsg-2) unstable; urgency=low

  * Restrict binutils-dev build-depend to exclude archs with cpus
    not supported by the "detailed stack traces" feature.
  * Check for __unix__ instead of __linux, so the "detailed stack traces"
    feature will work on non-linux archs.

 -- Yann Dirson <dirson@debian.org>  Fri, 18 May 2012 15:26:14 +0200

tulip (3.7.0dfsg-1) unstable; urgency=low

  * New upstream release:
    * drop patches included or superceded upstream:
      * "Make gzstream library name tunable as GZStreamLibrary"
      * "Use system FTGL, not the one shipped in thirtparty/"
      * "Rename gzstream library to gzstreamtlp-3.6"
      * "Rename libOGDF.so to libOGDFtlp-3.6.so"
    * Refreshed remaining patches:
      * Factored out references to doc-building jars in cmake files
      * Comment out INSTALL_RPATH flag on executables.
      * Disable python binding.
      * Use Debian-packaged jars.
      * Fix FTBFS with GCC 4.7.
    * Set the UBUNTU_PPA_BUILD cmake flag to benefit from this work.
    * Updated package names for new version and new lib names.
    * Builds and installs docs when using -DBUILD_DOC=ON.
  * Acknowledge NMU, sync with work done in parallel on the package:
    * Don't call dh_auto_build for arch-indep which do not need it
    * Remove -a and -i flags from calls where dh already adds them.
  * Separate shlib version with a dash in 3rdparty libs, so parsing the
    soname will correctly identify the version (thanks lintian...).
  * Move online help from tulip-doc into new tulip-help package, and let
    tulip recommend it.
  * Build-depend on binutils-dev to benefit from detailed stack traces on crash.
  * Use bash for tulip-config script with bashism (Closes: #530127).
  * When making docs, move expansion of the "doc-*" pattern from the shell
    up to make, so log failures on buildd can give meaningful information.
  * Updated debian/README.maint, to reflect the use of a collab-maint git repo.
  * Added Vcs-git and Vcs-browser control fields.
  * Declare "dfsg" version mangling in debian/watch (lintian).
  * Fixed continuation lines in debian/copyright (lintian).
  * Added GPL2 license paragraph for the (unused) ftgl subtree (lintian).
  * Bumped Standards-Version to 3.9.3, no other change.

 -- Yann Dirson <dirson@debian.org>  Sat, 12 May 2012 11:18:11 +0200

tulip (3.6.0dfsg-2.1) unstable; urgency=low

  * Non-maintainer upload.
  * Fix debian/rules, so the package compiles on the buildds. Closes: #650653.
  * Add gcc4.7_ftbfs patch to fix FTBFS with GCC 4.7. Closes: #667401.
  * Update Build-Depends on libpng-dev. Closes: #662526.
  * Bump debhelper Build-Depends to >= 9, as recommended by lintian.

 -- Regis Boudin <regis@debian.org>  Mon, 23 Apr 2012 22:52:11 +0200

=== debian/control ===
Source: tulip
Section: graphics
Priority: optional
Maintainer: Yann Dirson <dirson@debian.org>
Build-Depends: debhelper (>= 9), cmake, libqt4-dev, qt4-dev-tools, freeglut3-dev, docbook-to-man, libgl1-mesa-dev | libgl-dev, dh-buildinfo, libfreetype6-dev, libxml2-dev, libgle3-dev, libxml2-utils, graphviz, libjpeg-dev, libpng-dev, libftgl-dev, libglew1.5-dev, libqt4-opengl-dev, binutils-dev [any-i386 any-amd64]
Build-Depends-Indep: default-jre-headless, libsaxon-java, libxml-commons-resolver1.1-java, docbook-xsl, doxygen
Homepage: http://tulip-software.org/
Standards-Version: 3.9.3
Vcs-git: git://git.debian.org/git/collab-maint/tulip.git
Vcs-browser: http://git.debian.org/?p=collab-maint/tulip.git;a=summary

Package: tulip
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ttf-dejavu-core
Recommends: tulip-help
Suggests: tulip-doc
Description: System dedicated to the visualization of huge graphs
 Tulip is capable of managing graphs with up to 500,000 nodes and edges
 on relatively modest hardware (eg. 600MHz Pentium III, 256MB RAM).
 It includes the following features:
 .
  * 3D visualizations
  * 3D modifications
  * Plug-in support for easy evolution
  * Building of clusters and navigation into them
  * Automatic drawing of graphs
  * Automatic clustering of graphs
  * Automatic selection of elements
  * Automatic metric coloration of graphs

Package: tulip-help
Architecture: all
Depends: ${misc:Depends}
Suggests: tulip
Section: doc
Description: Online documentation for the Tulip graph-visualization system
 This package includes the online help browsable from the "Help" menu.

Package: tulip-doc
Architecture: all
Depends: ${misc:Depends}
Suggests: tulip
Section: doc
Description: Documentation for the Tulip graph-visualization system
 This package includes the Tulip User Handbook and the Tulip Developer
 Handbook in HTML format, as well as the manpages for the tulip libraries.

Package: libtulip-3.7
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Tulip graph library - core runtime
 Runtime for tulip, a system dedicated to the visualization of huge graphs.
 .
 This is the core of the system, excluding the OpenGL rendering capabilities.

Package: libtulip-dev
Section: libdevel
Architecture: any
Depends: libtulip-3.7 (= ${binary:Version}), libc6-dev, ${misc:Depends}
Conflicts: libtulip-dev
Replaces: tulip (<= 2), libtulip-ogl-dev, libtulip-qt4-dev
Suggests: automaken, tulip-doc
Description: Tulip graph library - core development files
 Headers and static libraries for tulip, a system dedicated to the
 visualization of huge graphs.
 .
 This is the core of the system, excluding the OpenGL rendering capabilities.

Package: libtulip-ogl-3.7
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Tulip graph library - OpenGL runtime
 Runtime for tulip, a system dedicated to the visualization of huge graphs.
 .
 This library contains the OpenGL rendering capabilities of the engine.

Package: libtulip-qt4-3.7
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Tulip graph library - Qt/OpenGL GUI runtime
 Runtime for tulip, a system dedicated to the visualization of huge graphs.
 .
 This library contains the Qt/OpenGL GUI support.

Package: libtulip-ogdf-3.7
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Tulip graph library - OGDF runtime
 Runtime for tulip, a system dedicated to the visualization of huge graphs.
 .
 This library contains the Open Graph Drawing Framework support.

Package: libogdf-tulip-3.7.0
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Open Graph Drawing Framework shared library, built for Tulip
 This is the Open Graph Drawing Framework library, built as a shared
 lib as required by Tulip.

Package: libgzstream-tulip-3.7.0
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: gzstream shared library, built for Tulip
 C++ iostream classes wrapping the zlib compression library.
 .
 This is the gzstream library, built as a shared lib as required by
 Tulip.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- -DCMAKE_SKIP_RPATH:BOOL=YES -DUBUNTU_PPA_BUILD=ON -DBUILD_DOC=ON

override_dh_auto_build-arch:
	dh_auto_build --parallel
	docbook-to-man debian/tulip.sgml > debian/tulip.1
override_dh_auto_build-indep:
	$(MAKE) -C "$(wildcard obj-*)" doc

override_dh_auto_install-indep:
	dh_auto_install -- -C docs
	mv debian/tmp/usr/share/doc/tulip debian/tmp/usr/share/doc/tulip-doc

override_dh_auto_install-arch:
	dh_auto_install
	install -D debian/tulip.1 debian/tmp/usr/share/man/man1/tulip.1

override_dh_install:
	dh_install --fail-missing

override_dh_auto_clean:
	dh_auto_clean
	rm -f debian/tulip.1
	rm -rf docs/doxygen/xml

=== debian/watch ===
version=3
opts=dversionmangle=s/dfsg$// \
 http://sf.net/auber/tulip-([\d.]*)(?:-src\.tar\.gz|\.tar\.bz2)
